/*
 * @file move_rv.hpp
 *
 * @since 16-07-2012
 * @author Krzysztof Czaiski
 */

#ifndef MOVE_RV_HPP_
#define MOVE_RV_HPP_

#include <boost/move/move.hpp>

#if defined(BOOST_NO_RVALUE_REFERENCES)

#define BOOST_MOVE_RV( x ) (x).move()

#define BOOST_MOVABLE(TYPE) \
    BOOST_COPYABLE_AND_MOVABLE_ALT(TYPE) \
    BOOST_RV_REF(ptr) move() { return *this; }

#else // BOOST_NO_RVALUE_REFERENCES

#define BOOST_MOVE_RV( x ) (x)

#define BOOST_MOVABLE(TYPE) \
    BOOST_COPYABLE_AND_MOVABLE_ALT(TYPE)

#endif // BOOST_NO_RVALUE_REFERENCES

#endif // MOVE_RV_HPP_
